import java.io.*;
import java.awt.*;
import java.awt.image.*;
import javax.imageio.*;



public class Convert{
	int MAX=10;		// Maximum of continuous characters
				// depends on starting string and end-string values

	public static void main(String ab[]){
		Convert convert=new Convert(ab[0]);
	}

	public Convert(String fname){
		try{
			System.out.println("Convert "+fname);

			BufferedImage img=ImageIO.read(new File(fname));
			int w=img.getWidth();
			int h=img.getHeight();
System.out.println("Width: "+w+" height: "+h);
			int[] pixels = new int[w*h];
			PixelGrabber pg = new PixelGrabber(img, 0,0, w, h, pixels, 0, w);
	
			pg.grabPixels(); //grab the pixels--load the buffer

			int[] unique=new int[1000];
			int uniquecounter=0;

			for(int i=0; i < w; i++){
				for(int j=0; j < h; j++){
				
					int cp=pixels[i+(j*w)];
					boolean ok=false;
					for(int k=0; k < uniquecounter && !ok; k++){
						if(unique[k]==cp)ok=true;
					}
					if(!ok){unique[uniquecounter++]=cp;}
				}
			}

			String pp="";
			for(int i=0; i < uniquecounter; i++){
				pp+=","+unique[i];
			}
System.out.println(pp);
// Now we are going to scan the pixels for repeats
			String output="";
			int oldc=0;
			int ccounter=0;
			int cindx=0;
			for(int i=0; i < h; i++){
				for(int j=0; j < w; j++){
					int indx=j+(i*w);
					int cp=pixels[indx];

					if(cp == oldc){
						if(ccounter++ > MAX){
							output+=""+(char)(48+ccounter)+(char)(cindx+65);
							ccounter=0;
						}

					}else{
						if(oldc!=0){
							// output 
							if(ccounter==0){
//System.out.println(" 1 keer ");
							for(int cc=0; cc<uniquecounter; cc++){if(cp==unique[cc]){cindx=cc;}}
								output+=""+(char)+(cindx+65);
							}else{
//System.out.println("counter: "+ccounter);
								output+=""+(char)(ccounter+48)+(char)(cindx+65);
								ccounter=0;
							}
						}
						// Search unique number
						for(int cc=0; cc<uniquecounter; cc++){if(cp==unique[cc]){cindx=cc;}}
						oldc=cp;

					}
				}
			}
System.out.println(""+output);

		}catch(Exception esg){System.out.println("FOUT : "+esg.toString());}

		
	}
}