//
//      EDITOR
//
//
//      4kBlock, Block4K, Blocker 4k, 4k Blocker
//
//      M.E.@2011
//
//      
//
import java.applet.Applet;	// duh
import java.awt.image.*;	// bufferedimage
import java.awt.*;		// graphics stuff
import java.awt.AWTEvent;	// enableEvents
// Action Events / keyevent
import java.awt.event.*;

import java.util.*;		// StringTokenizer

import java.net.*;		// Network
import java.io.*;



public class a extends Applet implements Runnable, ActionListener, KeyListener{
	
		// is debug?
		boolean debug=false;


		int WIDTH=640;
		int HEIGHT=480;
		// How many users can we have?
		final int MAXUSERS=10000;
                //
                // Game States
                //
		final int ERROR=1;
		final int INIT=99;
		final int PLAY=100;
        	final int RESTART=101;
	        final int DRAW=102;
	        final int NEXTLEVEL=103;
        	final int LEVELMENU=104;
	        final int EDITORMENU=105;
		final int EDITOR=106;
		final int MAKE=107;
		final int GRIDSELECT=108;
		final int LOAD=109;
		final int CUSTOMLEVELS=110;
		final int CUSTOMLEVELS2=111;
		final int USERMENU=112;
		final int USERMENUSELECT=113;
		final int LEVELMENUSELECT=114;
	
		final int EXTRA_X=200;
		final int EXTRA_Y=60;
		
		boolean play=false; 	// do we play after edit?
		int level=0;		// levelnr

	boolean keys[] = new boolean[65536];
	String Server="";
	java.awt.List userlist;
	int action=INIT;
	java.awt.List levellist;
	java.awt.Button newbutton;

		String userselect="";
		int userselectid=0;
		// Users
		String user[]=new String[MAXUSERS];
		int usernr[]=new int[MAXUSERS];
		int usercounter=0;

		String levelselect="";
		int levelselectid=0;
		// Users
		String levelnr[]=new String[MAXUSERS];
		String leveldata="";
		int levelcounter=0;

		// Error information
		String errortext="";

		int userid=0;
		String username="";


		int bestscore=0;
		int yourbestscore=0;
  public void start() {

                new Thread(this).start();
        }


	public void run(){

		// Userid
		userid=Integer.parseInt(getParameter("userid"));
		// Location of server-URL
		Server=getCodeBase().toString();

		setVisible(true);
		setLayout(null);

		addKeyListener(this);
		requestFocus();
		
		long t_;			// (sleep)Time
		final int sleeptime=60;

// GRID can be different for each level
int GRID=16;     
// Calculated TILESIZE depending on the grid?
int TILESIZE=24;                   
		int gridtype=0;




		

                     


		boolean ok=true;                      


		final int[] palette={-1,0,-7825556,-4181692,-131076,-12772074,-9107920,-6290656,-4181692,-2585538,-601851,-663950,-9484483,-5937295,-2195053,-11710362,-16751732,-14592873,-12409114,-11366365,-5845709,-15310047,-11642586,0,0,0};

		String slevels="";
		String levels="";
		//
                //	Data
		//
		int map[]=new int[(GRID*GRID)+4];
	        int tempmap[]=new int[(GRID*GRID)+4]; // keep a backup
	        int steps=0;


		final int maxslevels=5;
		int customcount=0;


		int x=0;		// player position

		
		final BufferedImage screen = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
		final Graphics g = screen.getGraphics();

		// omitting this saves a lot of bytes .. but it isn't that nice
		// 
                //g.setFont(new Font("Helvetica",Font.PLAIN,18));
                // But if we remove helvetica it saves another 4 bytes
		g.setFont(new Font("",Font.PLAIN,18));
		//
		// To input custom-levels;
		//

		String users="";	// All users that have completed levels

if(debug)System.out.println("Userid : "+userid);
                // Game loop.
		while (true) {
			// Use when you don't have a run method
			t_=System.currentTimeMillis();

			// fill background
			if(action != ERROR){
				g.setColor(new Color(palette[1]));
				g.fillRect(0, 0, WIDTH, HEIGHT);
			}

			if(action == INIT){
				String exec="network.php?cmd=getusers&userid="+userid;
if(debug)System.out.println("executing : "+exec);
				// Get all Users with completed levels

				users=execute(exec);
				if(users.length() > 0){
if(debug)System.out.println("users: "+users);
					if(users.indexOf("ERROR") > -1){
						errortext=users;
						action=ERROR;
					}else{
						StringTokenizer st=new StringTokenizer(users, "%");
						usercounter=0;
						while(st.hasMoreTokens()){
							String userdata=st.nextToken();
							StringTokenizer st2=new StringTokenizer(userdata, "*");
							usernr[usercounter]=Integer.parseInt(st2.nextToken());
							user[usercounter]=st2.nextToken();
							if(usernr[usercounter]==userid)username=user[usercounter];
if(debug)System.out.println("User: "+user[usercounter]+" = "+usernr[usercounter]);
							usercounter++;
						} // while users
						action=USERMENU;
					} // if error
				} // if user.length
				
			} // if action == INIT

			// replace all occurrences p with map
			int p=0; int p2=0; int ip=0;
			// Make background where player stands
			if(action == DRAW){
				map[x]=1;
			}
			
			if(action == DRAW || action == EDITOR){
				// -1 = left
				if((keys[1006] || keys[37]) && x > 2) {
					ip=-1;
					steps++;
					p=map[x+ip];
					p2=map[x-2];
					if(action == DRAW){
						// background move or remove same blocks
						if(p==1 || p==3){
							x--;
						}else{ 
							// equal and not boarder
							if(p==p2 && p!=2){map[x-1]=1; map[x-2]=1;x--;}
							else{
								// if not unmovable
								if(p2==1 && p!=2){map[x-2]=p;x--;}
							}
						}
					} // action == draw
					
	
				}
	
				// right
				if((keys[1007] || keys[39]) && x < (GRID*GRID)-1) {
					ip=+1;
					steps++;
					p=map[x+ip];
					p2=map[x+2];
					if(action == DRAW){
						if(p==1 || p==3){
							x++;
						}else{
							// if equal and not border
							if(p==p2 && p!=2){
								map[x+1]=1;map[x+2]=1;x++;
							}else{
								if(p2==1 && p!=2){map[x+2]=p;x++;}
							}
						}
					} // action == DRAW
				}

				// up
				if((keys[1004]||keys[38]) && x > GRID) {
					ip=-GRID;
					steps++;
					p=map[x+ip];
					if(action == DRAW){
						if(x > GRID*2) p2=map[x-GRID-GRID];
						if(p==1 || p==3){
							x-=GRID;
						}else{
							// if equal and not border
							 if(p==p2 && p!=2){map[x-GRID]=1; map[x-GRID-GRID]=1;x-=GRID;
							}else{
								if(p2==1 && p!=2){map[x-GRID-GRID]=p;x-=GRID;}
							}
						}
					} // action == draw
	
				}
	

				// down
				if((keys[1005]||keys[40]) && x < (GRID*GRID)-GRID) {
					ip=+GRID;	
					steps++;
					p=map[x+ip];
					if(action == DRAW){
						if(x < (GRID*GRID)-GRID*2) p2=map[x+GRID+GRID];
						if(p==1 || p==3){x+=GRID;
						}else{	// equal and not border
							 if(p==p2 && p!=2){map[x+GRID]=1; map[x+GRID+GRID]=1;x+=GRID;
							}else{
								if(p2==1 && p!=2){map[x+GRID+GRID]=p;x+=GRID;}
							}
						}
					} // action == draw
				}
	
				// finish
				if(p==3 && action == DRAW){
					map[x]=1;
					ok=false;
					for(int i=0; i < GRID*GRID && !ok; i++)if(map[i]==3)ok=true;
					// check if there are any other finish blocks
					if(!ok){
						String exec="network.php?cmd=score&userid="+userid+"&data="+userselectid+"."+level+"."+steps;
						String retval=execute(exec);
						action=LEVELMENU;
					}
				}
	
				if(action == DRAW){
					// put player on board
					map[x]=0;		// 0 = player
				}else{
					if(x+ip > -1 && x+ip < GRID*GRID)x=x+ip;
				}
				
			} // action == draw or edtior == no menu	

                        
			switch(action){
				case USERMENUSELECT:
					g.setColor(new Color(palette[0]));
					g.drawString("SELECT LEVEL SET", (WIDTH/2)-90,30);
					break;
				case USERMENU:
					newbutton=new Button("NEW LEVEL");
					newbutton.setBounds((WIDTH/2)-100,40,200,30);
					newbutton.addActionListener(this);
					newbutton.addKeyListener(this);
					add(newbutton);
	
					userlist=new java.awt.List(4, false);
					userlist.setBounds((WIDTH/2)-100,80,200,200);
					userlist.addKeyListener(this);
					boolean okuser=false;
					for(int i=0; i < usercounter; i++){
						userlist.add(user[i]);
						if(user[i].indexOf(username)>-1){
							okuser = true;
						}
					}
					if(usercounter > 0)userlist.select(0);
					if(!okuser){
						userlist.add(username);
					}
					
					userlist.addActionListener(this);
					add(userlist);	

					userlist.requestFocus();
					action=USERMENUSELECT;

					break;
				case LEVELMENUSELECT:
					g.setColor(new Color(palette[0]));
					g.drawString("SELECT LEVEL FROM USER: "+userselect, (WIDTH/2)-150,30);
					g.drawString("ESC = MAIN MENU",(WIDTH/2)-80,430);
					break;
				// Menu
				case LEVELMENU:
					if(newbutton!=null)
						remove(newbutton);
					if(userlist!=null)
						remove(userlist);
					requestFocus();


					levellist=new java.awt.List(4, false);
					levellist.addKeyListener(this);
					levellist.removeAll();
					levellist.setBounds((WIDTH/2)-100,50,200,200);
					for(int i=0; i < levelcounter; i++){
						levellist.add(levelnr[i]);
					}
					if(levelcounter > 0)levellist.select(0);
					levellist.addActionListener(this);
					add(levellist);	

					levellist.requestFocus();
					action=LEVELMENUSELECT;
					break;
				case MAKE:
					g.setColor(new Color(palette[0]));
					g.drawString("SELECT GRID", (WIDTH/2)-100,50);
					for(int i=0; i  < GRID*GRID; i++)map[i]=1;
					// Pick grid size
					for(int i=1; i < 8; i++){
						//g.drawString(""+(char)(i+96)+" = GRID "+(i*5)+"x"+(i*5)+"", 50,50+(i*24));
						g.drawString(""+(char)(i+64)+" = GRID "+(i*5)+"x"+(i*5)+"", (WIDTH/2)-100,50+(i*24));

					}
					g.drawString("ESC = MAIN MENU", (WIDTH/2)-100, 250);
					//for(int i=97; i < 128; i++){
					for(int i=64; i < 90; i++){
					
						if(keys[i]){
							//GRID=(i-96)*5;
							GRID=(i-64)*5;

							map=new int[(GRID*GRID)+4];
							tempmap=new int[(GRID*GRID)+4];
							for(int mi=0; mi < GRID*GRID; mi++)map[mi]=1;
							x=GRID+1;
requestFocus();
							action=EDITOR;
		
						}
					}

					x=1;
					break;

				case EDITOR:
					g.setColor(new Color(palette[0]));
					g.drawString("EDITOR", 280,20);
					g.drawString("F3=SAVE", 230,50);
					g.drawString("F2=PLAY", 340,50);
					// Keys = block colors
					for(int i=0; i < 23; i++){
						// box around black
						g.setColor(new Color(palette[i]));
						//g.drawString(""+(char)(i+97), 50+(i*24), 400);
						g.drawString(""+(char)(i+65), 50+(i*24), 400);
					}
					g.setColor(new Color(palette[0]));
					g.drawString("B = BACKGROUND ESC = MENU",(WIDTH/2)-130,440);


					// player-position
					// Get Key
					//for(int i=97; i < 126; i++){
					for(int i=65; i < 65+23; i++){
					
						if(keys[i]){
							//map[x]=i-97;
							map[x]=i-65;
						}
					}
					// PLAY
					if(keys[1009] || keys[113]){
						play=true;
						keys[1010]=true;
					}
					// SAVE
					if(keys[1010] || keys[114]){
						// GRID specification
//System.out.println("GRID SAVE  :"+GRID);
						// remove player-cursor
						x=0;
						leveldata="";
						int t=0;
						for(int i=0; i < GRID*GRID; i++){
							t=map[i];
							if(i<GRID)t=2;
							leveldata+=""+(char)(map[i]+65);
						}
						// store in database
						// Add the grid indicator before the data
            					String exec="network.php?cmd=store&userid="+userid+"&data="+level+"."+((char)(64+(GRID/5)))+leveldata;
if(debug)System.out.println("executing : "+exec);
                                        	String storedata=execute(exec);
if(debug)System.out.println("Result: "+storedata);
                                        	if(storedata.length() > 0){
                                                	if(storedata.indexOf("ERROR") > -1){
                                                       	 errortext=storedata;
                                                       	 action=ERROR;
							}
						}else{
							// When save is pressed	
							if(play){
								//locate the X
for(int i=0; i < GRID*GRID; i++){
	if(map[i]==0)x=i;
}
								action=DRAW;
								play=false;
							}else{
								// Stay here
								requestFocus();
								action=EDITOR;
							}
						}
					}
	
					break;
                                
				case NEXTLEVEL:
					// Go back to the first level
					if(level++ > maxslevels+customcount-1){level=1;}
//System.out.println("LEVEL : "+level);

					action=LOAD;
					break;
				case LOAD:
					steps=0;
//System.out.println("Loading level: "+level);
					// (re-)build level string					
//					levels=slevels+customlevels;
					
//System.out.println("Leves:"+levels);
					int a=0;
					ok=false;
					boolean begin=true;
					int levelcounter=0;
					// grid counter ; the level data counter
					int gc=0;
					while(a < leveldata.length() && !ok){
						char c=leveldata.charAt(a++);

//System.out.println("item: "+c+" (int:)"+((int)c));

						// begin of level .. what is the grid?
						// gc=gridcounter
						if(begin){
							GRID=(5*(c-64));
							map=new int[(GRID*GRID)+4];
							tempmap=new int[(GRID*GRID)+4];
							for(int mi=0; mi < GRID*GRID; mi++)map[mi]=1;


							begin=false;
							gc=0;
						}else{
							// Nr?
							if(c < 65){
								// . = end of level
								if(c==46){
									begin=true;
									if(levelcounter++==level-1){
//System.out.println("Ready loading level: "+level);
										ok=true;
									}
		
								}else{
									int nextc=levels.charAt(a++);
									// nr;
									for(int i=0; i<(c-48)+2; i++){
										map[gc++]=nextc-65;
									}
								}
							}else{
								// put the character on the map
//								map[gc++]=c-65;
								if( (map[gc++]=c-65)==0){x=gc-1;}
							}	
						} // if begin or in the data-area?
	
					}
					a=0; 
					ok=false;
					int cl=0;	// color level
					levelcounter=0;

					// IF user is owner of level
					if(userid == userselectid){
						action=EDITOR;
					}else{
						requestFocus();
						action=DRAW;
					}


					break;


                                        // 
                                        //
                                        // End of NEXTLEVEL


				case RESTART:
                                        for(int jjj=0; jjj<(GRID*GRID)+1; jjj++){
                                              map[jjj]=tempmap[jjj];
					}
        
                                        
                                        action=DRAW;
                                        break;
			}   // Switch action
			// we do this for both editor and play-states
        
			// boarder
			for(int i=0; i < (GRID*GRID)+1; i++){
				if(i < GRID)map[i]=2;
				if(i % GRID == 0)map[i]=2;
				if(i % GRID == GRID-1)map[i]=2;
				if(i > (GRID*GRID)-GRID)map[i]=2;
			}


				
			// Calculate game area
			TILESIZE=250/GRID;



                        //
                        // DRAW
                        //
                        // Do we need to draw the board?
			if(action == DRAW || action == EDITOR){

                                // Draw each grid item
				for(int i=0; i < GRID*GRID; i++){
					//
					// TODO : REMOVE ?  is it possible to remove this if?
					//
					if(action == DRAW || action == EDITOR ){

						int xx=EXTRA_X+((i%GRID)*TILESIZE);
	                                        int yy=EXTRA_Y+((i>0?i/GRID:0)*TILESIZE);
//System.out.println("Map["+i+"]="+map[i]);


						g.setColor(new Color(palette[map[i]]));
						// blink factor
						if(  (i==x?3:t_%500)<70 && (map[i]==3 || i==x))
							g.setColor(new Color(palette[i==x?0:1]));
						g.fillRect(xx,yy+TILESIZE,TILESIZE, TILESIZE);

                	                } // action == draw?
	                         } // for all grid items

				// steps + information
				//
				if(action == DRAW){
					g.setColor(new Color(palette[0]));
					g.drawString("STEPS :", EXTRA_X,EXTRA_Y);
					g.drawString(String.valueOf(steps), EXTRA_X+100,EXTRA_Y);

					// Score information
					g.drawString("BEST SCORE: "+bestscore+" YOUR BEST: "+yourbestscore, (WIDTH/2)-120,430);
				}

			} // action == DRAW
			//
			// ESCape
			//
			if(keys[27]){
//System.out.println("ESC .. action="+action);
				if(userlist!=null)
					remove(userlist);
				if(levellist!=null)
					remove(levellist);
				if(newbutton!=null)
					remove(newbutton);
				requestFocus();
				action = USERMENU;
				//action=INIT;
			}
			//
			// Reset keys
			for(int i=0; i < 65536; i++)keys[i]=false;

			if(action == ERROR){
    				g.setColor(new Color(palette[0]));
    				g.drawString(errortext, 100,300);
			}

			// sleep
			while((System.currentTimeMillis()-t_) < sleeptime){}
			// draw buffer to screen (avoid flicker)
			getGraphics().drawImage(screen,0,0,this);
		} // while true

	} // paint function

	// test using handleEvent		
//	public boolean handleEvent( java.awt.Event e){
	public void keyPressed(KeyEvent ke){
		keys[ke.getKeyCode()]=true;
	}
	public void keyReleased(KeyEvent ke){
		keys[ke.getKeyCode()]=false;
	}
	public void keyTyped(KeyEvent ke){
	}
	public void handleKey(java.awt.Event e){
		if(e.id==402 || e.id==403){
			String key=(e.toString().substring(e.toString().indexOf("key")+4));
			key=key.substring(0,key.indexOf(","));
			keys[Integer.parseInt(key)] = true;
		}
// get list command?
//System.out.println("event .."+e.toString());
		if(action == USERMENUSELECT){
			if(e.id == 1005){
				String select=(e.toString().substring(e.toString().indexOf("selected")+8));
if(debug)System.out.println("SELECT : "+select);
				
			}
		}
	}

	// Actions
	public void actionPerformed(ActionEvent ae){
if(debug)System.out.println("ae:"+ae.toString()+"ID: "+ae.getSource().getClass().getName()+" action ="+action);
		String obj=ae.getSource().getClass().getName();
		// New Level - Button
		if(action == USERMENUSELECT && obj.indexOf("Button") > -1){
			level=-1;
			remove(userlist);
			remove(newbutton);
			requestFocus();
			action=MAKE;
		}
		if(action == USERMENUSELECT && obj.indexOf("List") > -1){
			String us=userlist.getItem(userlist.getSelectedIndex());
if(debug)System.out.println("User select =  "+us);
			boolean ok=false;
			for(int i=0; i < usercounter && !ok; i++){
				if(user[i].indexOf(us)==0){
if(debug)System.out.println("usernr: "+usernr[i]);
					userselect=user[i];
					userselectid=usernr[i];
//
// get levels from user
//
					String exec="network.php?cmd=getlevels&userid="+userid+"&data="+userselectid;
if(debug)System.out.println("executing : "+exec);
					String userdata=execute(exec);
					if(userdata.length() > 0){
if(debug)System.out.println("UserData : "+userdata);
						if(userdata.indexOf("ERROR") > -1){
							errortext=userdata;
							action=ERROR;
						}else{
							//levelnr 
							//leveldata from user
							StringTokenizer st=new StringTokenizer(userdata, "%");
							levelcounter=0;
							while(st.hasMoreTokens()){
								levelnr[levelcounter++]=st.nextToken();
							}
							requestFocus();
							action=LEVELMENU;
						}
					}
					ok=true;
				}
			}
		}

		if(action == LEVELMENUSELECT ){
			String us=levellist.getItem(levellist.getSelectedIndex());
if(debug)System.out.println("level select =  "+us);
			levelselect=us;
			level=Integer.parseInt(us);
				// use the userid for the level number :)
				String exec="network.php?cmd=getlevel&userid="+userid+"&data="+userselectid+"."+us;
if(debug)System.out.println("executing : "+exec);
				// Get all Users with completed levels
				leveldata=execute(exec);
				if(leveldata.length() > 0){
					if(leveldata.indexOf("ERROR") > -1){
						errortext=leveldata;
						action=ERROR;
					}else{
if(debug)System.out.println("Leveldta: "+leveldata);

						requestFocus();
						action=LOAD;
					}
				} // leveldata or not?
			if(levellist!=null)
				remove(levellist);
			requestFocus();
			
		}
			
	}



// Execute PHP scripts
        //
        public String execute(String php){
                String retval="";
                String test=new String("");
                Integer I;
                Integer J;
                String inputLine;
                Date d=new Date();

                  try{
                    URL Url = new URL(Server+php+"&dummy="+d.getTime());

//System.out.println("EXECUTING Url opening: "+Url.toString());
                        URLConnection uc = Url.openConnection();
                       BufferedReader in = new BufferedReader(new InputStreamReader(uc.getInputStream()));
                      while ((inputLine = in.readLine()) != null){
                       // Script is executing .. no output is given!
                        retval+=inputLine;
                       }


                   }catch(Exception ef){
if(debug)System.out.println("Error getting result from: "+php+" : "+ef.toString());
                        retval="";
                  }

                return retval;

        }

}
