//
//
//      4kBlock, Block4K
//
//      M.E.@2010,2011
//
//      
//      A 4k prototype of an on-line game where you can 
//	make your own graphics.
//
//
//
import java.applet.Applet;	// duh
import java.awt.image.*;	// bufferedimage
import java.awt.*;		// graphics stuff
import java.awt.AWTEvent;	// enableEvents
import java.awt.event.KeyEvent;	// Keys




public class a extends Applet {

	// avoid different methods .. init and paint = only paint
	// Unfortunately the event (keyboard/mouse) will need an extra method

	boolean keys[] = new boolean[65536];

	public void init(){
		enableEvents(AWTEvent.KEY_EVENT_MASK);
		setVisible(true);

		requestFocus();
		
		long t_;			// (sleep)Time
		final int sleeptime=120;

// Calculated TILESIZE depending on the grid?
int TILESIZE=24;                   
// GRID can be different for each level
int GRID=16;     
// Calculated offset based on the GRID
int EXTRA_X=3;                       
int EXTRA_Y=3;                       



                //
                // Game States
                //
		final int PLAY=100;
        	final int RESTART=101;
	        final int DRAW=102;
	        final int NEXTLEVEL=103;
        	final int LEVELMENU=104;
	        final int DOWN=105;
		// Start action
		int action=NEXTLEVEL;

                     
/*
		final int red=-65536;	
		final int white=-1;
	        final int black=-16777216;
	        final int gray=-8355712;
*/


		boolean ok=true;                      



		final String levels="A6BA9B2BD6B.A6BA8BCC1BD6B.";
		// unique pallete for all the levels;
		final int[] palette={-1,-16777216,-65536,-8355712};
		final String levelcolors="ABCD.ABCD.";
		int colors[]=new int[30];
		//
                //
		int map[]=new int[(GRID*GRID)+4];
	        int tempmap[]=new int[(GRID*GRID)+4]; // keep a backup





		int level=0;
		final int maxlevels=16;


		int x=0;		// player position

	        int score=0;
		
		final BufferedImage screen = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
		final Graphics g = screen.getGraphics();

		// omitting this saves a lot of bytes .. but it isn't that nice
		// 
                //g.setFont(new Font("Helvetica",Font.PLAIN,18));
                // But if we remove helvetica it saves another 4 bytes
		g.setFont(new Font("",Font.PLAIN,18));




                // Game loop.
		while (true) {
			// Use when you don't have a run method
			t_=System.currentTimeMillis();

			// replace all occurrences p with map
			int p=0; int p2=0;
			// Make background where player stands
			map[x]=1;
			if(keys[KeyEvent.VK_LEFT] && x > 2) {
				p=map[x-1];
				p2=map[x-2];
				// background move or remove same blocks
				if(p==1){
					x--;
				}else{ 
					if(p==p2){map[x-1]=1; map[x-2]=1;x--;}
					else{
						if(p2==1){map[x-2]=p;x--;}
					}
				}
				

			}

			if(keys[KeyEvent.VK_RIGHT] && x < (GRID*GRID)-1) {

				p=map[x+1];
				p2=map[x+2];
				if(p==1){
					x++;
				}else{
					if(p==p2){
						map[x+1]=1;map[x+2]=1;x++;
					}else{
						if(p2==1){map[x+2]=p;x++;}
					}
				}
			}
			if(keys[KeyEvent.VK_UP] && x > GRID) {
				p=map[x-GRID];
				if(x > GRID*2) p2=map[x-GRID-GRID];
				if(p==1){
					x-=GRID;
				}else{
					 if(p==p2){map[x-GRID]=1; map[x-GRID-GRID]=1;x-=GRID;
					}else{
						if(p2==1){map[x-GRID-GRID]=p;x-=GRID;}
					}
				}

			}

			if(keys[KeyEvent.VK_DOWN] && x < (GRID*GRID)-GRID) {
				p=map[x+GRID];
				if(x < (GRID*GRID)-GRID*2) p2=map[x+GRID+GRID];
				if(p==1){x+=GRID;
				}else{
					 if(p==p2){map[x+GRID]=1; map[x+GRID+GRID]=1;x+=GRID;
					}else{
						if(p2==1){map[x+GRID+GRID]=p;x+=GRID;}
					}
				}

			}
			// finish
			if(p==3)action=NEXTLEVEL;

			// put player on board
			map[x]=0;
			
        	        //
                	// Sleeper. This timer will change when we need to pause
	                //


			// Render
			g.setColor(new Color(colors[1]));
			g.fillRect(0, 0, 800, 600);
                        
			switch(action){
				case LEVELMENU:
					g.setColor(new Color(colors[0]));
					for(int i=1; i<maxlevels+1; i++)
						g.drawString("LEVEL "+(i), EXTRA_X+150, (EXTRA_Y-TILESIZE)+((1+i)*TILESIZE));
					break;

                                
				case NEXTLEVEL:
					action=DRAW;
					// Go back to the first level
					if(level++ > maxlevels-1){level=1;}
System.out.println("LEVEL : "+level);
					for(int i=0; i<(GRID*GRID)+1   ;i++) {map[i]=1;}

					// levelcolors
					

					int a=0;
					ok=false;
					boolean begin=true;
					int levelcounter=0;
					// grid counter ; the level data counter
					int gc=0;
					while(a < levels.length() && !ok){
						char c=levels.charAt(a++);

//						System.out.println("item: "+c+" (int:)"+((int)c));

						// begin of level .. what is the grid?
						// gc=gridcounter
						if(begin){
							GRID=(5+(c-65));
							begin=false;
							gc=0;
						}else{
							// Nr?
							if(c < 65){
								// . = end of level
								if(c==46){
									begin=true;
									if(levelcounter++==level-1){
//System.out.println("Ready loading level: "+level);
										ok=true;
									}
		
								}else{
									int nextc=levels.charAt(a++);
									// nr;
									for(int i=0; i<(c-49)+1; i++){
	

										map[gc++]=nextc-65;
									}
								}
							}else{
//								map[gc++]=c-65;
								if( (map[gc++]=c-65)==0){x=gc-1;}
							}	
						} // if begin or in the data-area?
	
					}
					a=0; 
					ok=false;
					int cl=0;	// color level
					levelcounter=0;
					// Colors
					while(a < levelcolors.length() && !ok){
						char c=levelcolors.charAt(a);
						if(c==46){
							if(levelcounter++==level-1){
//System.out.println("Ready loading COLOR level: "+level);

								ok=true;
							}
							cl=0;
						}else{
//System.out.println("palette reference: "+((int)c));
							colors[cl++]=palette[c-65];
						}
						a++;
					}

					// undo grid
					for(int i=0; i < GRID*GRID; i++)tempmap[i]=map[i];


					break;


                                        // 
                                        //
                                        // End of NEXTLEVEL


				case RESTART:
                                        for(int jjj=0; jjj<(GRID*GRID)+1; jjj++){
                                              map[jjj]=tempmap[jjj];
					}
        
                                        
                                        action=DRAW;
                                        break;
			}   // Switch action
        


                        //
                        // DRAW
                        //
                        // Do we need to draw the board?
			if(action == DRAW || action == PLAY || action == RESTART){

                                // Draw each grid item
				for(int i=0; i < GRID*GRID; i++){
                                        // Show the lines of the different players
                                        //
	                                // do not show orderlines when we are playing back                      
					if(action == DRAW ){

						int xx=EXTRA_X+((i%GRID)*TILESIZE);
	                                        int yy=EXTRA_Y+((i>0?i/GRID:0)*TILESIZE);
//System.out.println("Map["+i+"]="+map[i]);

						g.setColor(new Color(colors[map[i]]));
						// blink factor
//						if( (t_%1000 > 800 && map[i]==0) || (t_%1000<70 && map[i]==3))
						if(  (t_%1000<70 && map[i]==3))
							g.setColor(new Color(colors[1]));
						g.fillRect(xx,yy+TILESIZE,TILESIZE, TILESIZE);

                	                } // action == draw?
	                         } // for all grid items
			} // action == DRAW

			//
			// Score + information
			//
			g.setColor(new Color(colors[0]));
			g.drawString("SCORE :", 0,55);
			g.drawString(String.valueOf(score), 70,55);


			// sleep
			while((System.currentTimeMillis()-t_) < sleeptime){}
			// draw buffer to screen (avoid flicker)
			getGraphics().drawImage(screen,0,0,this);
		} // while true

	} // paint function
		
	public void processKeyEvent(final KeyEvent e) {
		 keys[e.getKeyCode()] = (e.getID() == KeyEvent.KEY_PRESSED);

	}	


}
